#ifndef COURSE_H
#define COURSE_H

#include <sdbus-c++/Types.h>
#include <unordered_map>
#define IMGUI_DEFINE_MATH_OPERATORS
#include <imgui.h>
#include <memory>
#include <raylib.h>
#include <sdbus-c++/IConnection.h>
#include <sdbus-c++/IProxy.h>
#include <string>

class RayTexture {
  public:
    Texture tex{};
    std::string path;
    RayTexture();
    explicit RayTexture(Image img);
    RayTexture(const RayTexture& other);
    RayTexture& operator=(const RayTexture& other);
    ~RayTexture();
};

class MprisPlayer {
  public:
    std::unique_ptr<sdbus::IConnection> bus_connection;
    std::unique_ptr<sdbus::IProxy> PlayerProxy;
    sdbus::InterfaceName mp2;
    sdbus::MethodName playpause;
    RayTexture tex;
    std::string image_path_cache;
    explicit MprisPlayer(std::string servicename);
    void PausePlay();
    void Refresh();
    void UpdateTexture();
    void Next();
    void Prev();
    std::string identity;
    std::string playstate;
    std::string GetIdentity();
    std::unordered_map<std::string, sdbus::Variant> current_metadata;
    std::unordered_map<std::string, sdbus::Variant> GetCurrentMetadata();
};


#endif
